/////////////////////////////////////////////////////////////////////////////////
// Auxiliary mathematics class.
// Contains the implementations for various interpolation methods,
// as well as implementations for various procedural generation functionality.
//
// Version: 270612_01
/////////////////////////////////////////////////////////////////////////////////

#ifndef _AUXMATHS_H_
#define _AUXMATHS_H_

#include <math.h>
#include <iostream>
#include <glut.h>

using namespace std; //for debug streaming to console

inline float Fade(float t)
{
	return (powf(t, 3) * (t * (t * 6 - 15) + 10));
}

//Lerp: Linear time-delta dependant interpolation from point a to point b.
inline float Lerp(float t, float a, float b)
{
	return (a + t * (b - a));
}

////////////////////////////////////////////////////
//Tesselation topology specific functionality.
////////////////////////////////////////////////////

#endif