//////////////////////////////////////////////////////////////////////////////////////////////////////////
// Noise generation interface.
// Based on the noise implementation featured in this article: 
// http://www.gamedev.net/page/resources/_/technical/game-programming/simple-clouds-part-1-r2085
//
// Written by Vladeta Stojanovic.
//
// Version: 170612_01
/////////////////////////////////////////////////////////////////////////////////////////////////////////

#ifndef _NOISE_H_
#define _NOISE_H_

#include <cstdlib>
#include <ctime> 
#include <math.h>
#include "auxMaths.h"


inline float Noise1D( int x)
{
    x = (x<<13)^x;
    return (((x * (x * x * 15731 + 789221) + 1376312589) & 0x7fffffff) / 2147483648.0);
}

inline float Noise2D(int x, int y, int random)
{
    int n = x + y * 57 + random * 131;
    n = (n<<13) ^ n;
    return (1.0f - ( (n * (n * n * 15731 + 789221) +
            1376312589)&0x7fffffff)* 0.000000000931322574615478515625f);
}

#endif